#include<iostream>
using namespace std;
int n,q,x[200000],y[200000],l[200000],r[200000];
void unos()
{
    cin>>n>>q;
    for(int i=1;i<=n;i++)
        cin>>x[i];
    for(int i=0;i<q;i++)
        cin>>l[i]>>r[i];
}
int upit(int a, int b)
{
    return a&b;
}
void program()
{
    int i,s,j;
    for(i=0;i<q;i++)
    {
       // cin>>l>>r;
        y[i]=x[l[i]];
        for(j=l[i]+1;j<=r[i];j++)
        {
            if (y[i]==0)
                break;
            if (x[j]==0)
            {
                y[i]=0;
                break;
            }
            y[i]=y[i]&x[j];
        }
    }
    for(i=0;i<q;i++)
        cout<<y[i]<<endl;
}
int main()
{
    unos();
    program();
}